/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.33 Revision 1.123
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.33 2009/05/12 14:21:22 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.123 2012/03/08 14:24:40 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
11# @DESCRIPTION: 9# @DESCRIPTION:
12# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
13 11
14inherit eutils multilib toolchain-funcs flag-o-matic versionator
15
16IUSE="${IUSE} custom-cxxflags debug pch"
17
18case "${PV}" in 12case ${EAPI} in
19 4.?.?_rc*) 13 2|3|4) : ;;
20 SRCTYPE="${SRCTYPE:-opensource-src}" 14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
21 MY_PV="${PV/_rc/-rc}"
22 ;;
23 *)
24 SRCTYPE="${SRCTYPE:-opensource-src}"
25 MY_PV="${PV}"
26 ;;
27esac 15esac
28MY_P=qt-x11-${SRCTYPE}-${MY_PV} 16
17inherit base eutils multilib toolchain-funcs flag-o-matic versionator
18
19MY_PV=${PV/_/-}
20MY_P=qt-everywhere-opensource-src-${MY_PV}
21
22HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/"
23SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
24LICENSE="|| ( LGPL-2.1 GPL-3 )"
25
26IUSE="aqua debug pch"
27
28[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] &&
29[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
30 IUSE+=" +exceptions"
31
32if version_is_at_least 4.7.99999999; then
33 IUSE+=" c++0x qpa"
34fi
35
36DEPEND="dev-util/pkgconfig"
37RDEPEND="
38 !<x11-libs/qt-assistant-${PV}
39 !>x11-libs/qt-assistant-${PV}-r9999
40 !<x11-libs/qt-core-${PV}
41 !>x11-libs/qt-core-${PV}-r9999
42 !<x11-libs/qt-dbus-${PV}
43 !>x11-libs/qt-dbus-${PV}-r9999
44 !<x11-libs/qt-declarative-${PV}
45 !>x11-libs/qt-declarative-${PV}-r9999
46 !<x11-libs/qt-demo-${PV}
47 !>x11-libs/qt-demo-${PV}-r9999
48 !<x11-libs/qt-gui-${PV}
49 !>x11-libs/qt-gui-${PV}-r9999
50 !<x11-libs/qt-multimedia-${PV}
51 !>x11-libs/qt-multimedia-${PV}-r9999
52 !<x11-libs/qt-opengl-${PV}
53 !>x11-libs/qt-opengl-${PV}-r9999
54 !<x11-libs/qt-openvg-${PV}
55 !>x11-libs/qt-openvg-${PV}-r9999
56 !<x11-libs/qt-phonon-${PV}
57 !>x11-libs/qt-phonon-${PV}-r9999
58 !<x11-libs/qt-qt3support-${PV}
59 !>x11-libs/qt-qt3support-${PV}-r9999
60 !<x11-libs/qt-script-${PV}
61 !>x11-libs/qt-script-${PV}-r9999
62 !<x11-libs/qt-sql-${PV}
63 !>x11-libs/qt-sql-${PV}-r9999
64 !<x11-libs/qt-svg-${PV}
65 !>x11-libs/qt-svg-${PV}-r9999
66 !<x11-libs/qt-test-${PV}
67 !>x11-libs/qt-test-${PV}-r9999
68 !<x11-libs/qt-webkit-${PV}
69 !>x11-libs/qt-webkit-${PV}-r9999
70 !<x11-libs/qt-xmlpatterns-${PV}
71 !>x11-libs/qt-xmlpatterns-${PV}-r9999
72"
73
29S=${WORKDIR}/${MY_P} 74S=${WORKDIR}/${MY_P}
30 75
31HOMEPAGE="http://www.qtsoftware.com/" 76# @FUNCTION: qt4-build_pkg_setup
32SRC_URI="http://download.qtsoftware.com/qt/source/${MY_P}.tar.bz2" 77# @DESCRIPTION:
33 78# Sets up PATH and LD_LIBRARY_PATH.
34case "${PV}" in
35 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
36 *) ;;
37esac
38
39if version_is_at_least 4.5 ${PV} ; then
40 LICENSE="|| ( LGPL-2.1 GPL-3 )"
41fi
42
43qt4-build_pkg_setup() { 79qt4-build_pkg_setup() {
44 # EAPI=2 ebuilds set use-deps, others need this: 80 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
45 if [[ $EAPI != 2 ]]; then 81
46 # Make sure debug setting corresponds with qt-core (bug 258512) 82 # Protect users by not allowing downgrades between releases
47 if [[ $PN != "qt-core" ]]; then 83 # Downgrading revisions within the same release should be allowed
48 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 84 if has_version '>'${CATEGORY}/${P}-r9999; then
49 ~x11-libs/qt-core-${PV} debug" 85 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
86 eerror "Sanity check to keep you from breaking your system:"
87 eerror " Downgrading Qt is completely unsupported and will break your system!"
88 die "aborting to save your system"
89 else
90 ewarn "Downgrading Qt is completely unsupported and will break your system!"
50 fi 91 fi
92 fi
51 93
52 # Check USE requirements 94 if [[ ${PN} == qt-webkit ]]; then
53 qt4-build_check_use 95 eshopts_push -s extglob
96 if is-flagq '-g?(gdb)?([1-9])'; then
97 echo
98 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
99 ewarn "You may experience really long compilation times and/or increased memory usage."
100 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
101 ewarn "For more info check out bug #307861"
102 echo
54 fi 103 fi
55 # Set up installation directories 104 eshopts_pop
56 QTBASEDIR=/usr/$(get_libdir)/qt4 105 fi
57 QTPREFIXDIR=/usr
58 QTBINDIR=/usr/bin
59 QTLIBDIR=/usr/$(get_libdir)/qt4
60 QTPCDIR=/usr/$(get_libdir)/pkgconfig
61 QTDATADIR=/usr/share/qt4
62 QTDOCDIR=/usr/share/doc/qt-${PV}
63 QTHEADERDIR=/usr/include/qt4
64 QTPLUGINDIR=${QTLIBDIR}/plugins
65 QTSYSCONFDIR=/etc/qt4
66 QTTRANSDIR=${QTDATADIR}/translations
67 QTEXAMPLESDIR=${QTDATADIR}/examples
68 QTDEMOSDIR=${QTDATADIR}/demos
69 106
70 PLATFORM=$(qt_mkspecs_dir)
71
72 PATH="${S}/bin:${PATH}" 107 PATH="${S}/bin${PATH:+:}${PATH}"
108 if [[ ${CHOST} != *-darwin* ]]; then
73 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 109 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
110 else
111 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
112 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
113 # platform detection. Note: needs to come before any directories to
114 # avoid extract failure.
115 [[ ${CHOST} == *-apple-darwin* ]] && \
116 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
117 ${QT4_EXTRACT_DIRECTORIES}"
118 fi
74 119
75 if ! version_is_at_least 4.1 $(gcc-version) ; then 120 if ! version_is_at_least 4.1 $(gcc-version); then
76 ewarn "Using a GCC version lower than 4.1 is not supported!" 121 ewarn "Using a GCC version lower than 4.1 is not supported."
77 echo
78 ebeep 3
79 fi 122 fi
80
81 if use custom-cxxflags; then
82 echo
83 ewarn "You have set USE=custom-cxxflags, which means Qt will be built with the"
84 ewarn "CXXFLAGS you have set in /etc/make.conf. This is not supported, and we"
85 ewarn "recommend to unset this useflag. But you are free to experiment with it."
86 ewarn "Just do not start crying if it breaks your system, or eats your kitten"
87 ewarn "for breakfast. ;-) "
88 echo
89 fi
90
91} 123}
92 124
125# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
126# @DESCRIPTION:
127# Arguments for build_target_directories. Takes the directories in which the
128# code should be compiled. This is a space-separated list.
129
130# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
131# @DESCRIPTION:
132# Space-separated list including the directories that will be extracted from
133# Qt tarball.
134
135# @FUNCTION: qt4-build_src_unpack
136# @DESCRIPTION:
137# Unpacks the sources.
93qt4-build_src_unpack() { 138qt4-build_src_unpack() {
94 local target targets licenses 139 setqtenv
95 if version_is_at_least 4.5 ${PV} ; then 140
96 licenses="LICENSE.GPL3 LICENSE.LGPL" 141 local tarball="${MY_P}.tar.gz" target= targets=
97 else 142 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
98 licenses="LICENSE.GPL2 LICENSE.GPL3"
99 fi
100 for target in configure ${licenses} projects.pro \
101 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 143 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
102 ${QT4_EXTRACT_DIRECTORIES}; do 144 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
145 do
103 targets="${targets} ${MY_P}/${target}" 146 targets+="${MY_P}/${target} "
104 done 147 done
105 148
106 echo tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 149 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
107 tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 150 tar -xzf "${DISTDIR}/${tarball}" ${targets}
108 151 eend $? || die "failed to unpack"
109 case "${PV}" in
110 4.4.?)
111 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
112 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
113 ;;
114 esac
115
116 # Be backwards compatible for now
117 if [[ $EAPI != 2 ]]; then
118 qt4-build_src_prepare
119 fi
120} 152}
121 153
154# @ECLASS-VARIABLE: PATCHES
155# @DEFAULT_UNSET
156# @DESCRIPTION:
157# PATCHES array variable containing all various patches to be applied.
158# This variable is expected to be defined in global scope of ebuild.
159# Make sure to specify the full path. This variable is utilised in
160# src_unpack/src_prepare phase, based on EAPI.
161#
162# @CODE
163# PATCHES=( "${FILESDIR}/mypatch.patch"
164# "${FILESDIR}/patches_folder/" )
165# @CODE
166
167# @FUNCTION: qt4-build_src_prepare
168# @DESCRIPTION:
169# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
170# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
122qt4-build_src_prepare() { 171qt4-build_src_prepare() {
172 setqtenv
123 cd "${S}" 173 cd "${S}"
124 174
175 if version_is_at_least 4.7; then
176 # fix libX11 dependency on non X packages
177 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
178 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
179
180 qt_assistant_cleanup
181 fi
182
183 if use aqua; then
184 # provide a proper macx-g++-64
185 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
186
187 sed -e '/^CONFIG/s:app_bundle::' \
188 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
189 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
190 fi
191
125 if [[ ${PN} != qt-core ]]; then 192 if [[ ${PN} != qt-core ]]; then
126 skip_qmake_build_patch 193 skip_qmake_build
127 skip_project_generation_patch 194 skip_project_generation
128 symlink_binaries_to_buildtree 195 symlink_binaries_to_buildtree
129 fi 196 fi
130 197
131 if ! use custom-cxxflags;then 198 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
132 # Don't let the user go too overboard with flags. 199 # qmake bus errors with -O2 but -O3 works
133 strip-flags
134 replace-flags -O3 -O2 200 replace-flags -O2 -O3
135 fi 201 fi
136 202
137 # Bug 178652 203 # Bug 178652
138 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 204 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
139 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 205 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
140 append-flags -fno-gcse 206 append-flags -fno-gcse
141 fi 207 fi
142 208
209 if use_if_iuse c++0x; then
210 echo
211 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
212 ewarn "this is an official standard, some of the reverse dependencies"
213 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
214 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
215 ewarn "disabled."
216 echo
217 append-flags -std=c++0x
218 fi
219
143 # Unsupported old gcc versions - hardened needs this :( 220 # Unsupported old gcc versions - hardened needs this :(
144 if [[ $(gcc-major-version) -lt "4" ]] ; then 221 if [[ $(gcc-major-version) -lt 4 ]]; then
145 ewarn "Appending -fno-stack-protector to CXXFLAGS" 222 ewarn "Appending -fno-stack-protector to CXXFLAGS"
146 append-cxxflags -fno-stack-protector 223 append-cxxflags -fno-stack-protector
147 # Bug 253127 224 # Bug 253127
148 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 225 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
149 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 226 -i mkspecs/common/g++.conf || die
150 fi 227 fi
228
229 # Bug 261632
230 if use ppc64; then
231 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
232 append-flags -mminimal-toc
233 fi
234
235 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
236 sed -e "/^SYSTEM_VARIABLES=/i \
237 CC='$(tc-getCC)'\n\
238 CXX='$(tc-getCXX)'\n\
239 CFLAGS='${CFLAGS}'\n\
240 CXXFLAGS='${CXXFLAGS}'\n\
241 LDFLAGS='${LDFLAGS}'\n" \
242 -i configure \
243 || die "sed SYSTEM_VARIABLES failed"
244
245 # Respect CC, CXX, LINK and *FLAGS in config.tests
246 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
247 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
248 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
249 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
250 || die "sed config.tests failed"
251
252 # Strip predefined CFLAGS from mkspecs (bug 312689)
253 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
151 254
152 # Bug 172219 255 # Bug 172219
256 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
257
258 if [[ ${CHOST} == *-darwin* ]]; then
259 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
260 # crippled (by design) :/
261 sed \
153 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 262 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
154 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 263 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
155 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 264 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
156 -e "s:X11R6/::" \ 265 -e "s:-arch\s\w*::g" \
157 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 266 -i mkspecs/common/mac-g++.conf \
267 || die "sed mkspecs/common/mac-g++.conf failed"
158 268
159 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 269 # Fix configure's -arch settings that appear in qmake/Makefile and also
160 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 270 # fix arch handling (automagically duplicates our -arch arg and breaks
161 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 271 # pch). Additionally disable Xarch support.
162 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 272 sed \
273 -e "s:-arch i386::" \
274 -e "s:-arch ppc::" \
275 -e "s:-arch x86_64::" \
276 -e "s:-arch ppc64::" \
277 -e "s:-arch \$i::" \
278 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
279 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
280 -e "s:-Xarch_x86_64::g" \
281 -e "s:-Xarch_ppc64::g" \
282 -i configure mkspecs/common/mac-g++.conf \
283 || die "sed -arch/-Xarch failed"
163 284
164} 285 # On Snow Leopard don't fall back to 10.5 deployment target.
286 if [[ ${CHOST} == *-apple-darwin10 ]]; then
287 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
288 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
289 -i configure mkspecs/common/mac-g++.conf \
290 || die "sed deployment target failed"
291 fi
292 fi
165 293
294 # this one is needed for all systems with a separate -liconv, apart from
295 # Darwin, for which the sources already cater for -liconv
296 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
297 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
298 -i config.tests/unix/iconv/iconv.pro \
299 || die "sed iconv.pro failed"
300 fi
301
302 # we need some patches for Solaris
303 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
304 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
305 # use GCC over SunStudio
306 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
307 # do not flirt with non-Prefix stuff, we're quite possessive
308 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
309 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
310
311 base_src_prepare
312}
313
314# @FUNCTION: qt4-build_src_configure
315# @DESCRIPTION:
316# Default configure phase
166qt4-build_src_configure() { 317qt4-build_src_configure() {
318 setqtenv
167 319
168 myconf="$(standard_configure_options) ${myconf}"
169
170 echo ./configure ${myconf}
171 ./configure ${myconf} || die "./configure failed"
172}
173
174qt4-build_src_compile() {
175 # Be backwards compatible for now
176 if [[ $EAPI != 2 ]]; then
177 qt4-build_src_configure
178 fi
179
180 build_directories "${QT4_TARGET_DIRECTORIES}"
181}
182
183qt4-build_src_install() {
184 install_directories "${QT4_TARGET_DIRECTORIES}"
185 install_qconfigs
186 fix_library_files
187}
188
189standard_configure_options() {
190 local myconf="" 320 local conf="
191 321 -prefix ${QTPREFIXDIR}
192 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 322 -bindir ${QTBINDIR}
193 323 -libdir ${QTLIBDIR}
194 # Disable visibility explicitly if gcc version isn't 4 324 -docdir ${QTDOCDIR}
195 if [[ "$(gcc-major-version)" -lt "4" ]]; then 325 -headerdir ${QTHEADERDIR}
196 myconf="${myconf} -no-reduce-exports" 326 -plugindir ${QTPLUGINDIR}
197 fi 327 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
198 328 -datadir ${QTDATADIR}
199 # precompiled headers doesn't work on hardened, where the flag is masked. 329 -translationdir ${QTTRANSDIR}
200 if use pch; then 330 -sysconfdir ${QTSYSCONFDIR}
201 myconf="${myconf} -pch" 331 -examplesdir ${QTEXAMPLESDIR}
202 else 332 -demosdir ${QTDEMOSDIR}
203 myconf="${myconf} -no-pch" 333 -opensource -confirm-license
204 fi 334 -shared -fast -largefile -stl -verbose
205 335 -nomake examples -nomake demos"
206 if use debug; then
207 myconf="${myconf} -debug -no-separate-debug-info"
208 else
209 myconf="${myconf} -release -no-separate-debug-info"
210 fi
211 336
212 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 337 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
213 # $(tc-arch). Therefore we convert it to supported values. 338 # $(tc-arch). Therefore we convert it to supported values.
214 case "$(tc-arch)" in 339 case "$(tc-arch)" in
215 amd64) myconf="${myconf} -arch x86_64" ;; 340 amd64|x64-*) conf+=" -arch x86_64" ;;
341 ppc-macos) conf+=" -arch ppc" ;;
216 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 342 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
343 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
344 x86-macos) conf+=" -arch x86" ;;
217 x86|x86-*) myconf="${myconf} -arch i386" ;; 345 x86|x86-*) conf+=" -arch i386" ;;
218 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 346 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
219 hppa|sh) myconf="${myconf} -arch generic" ;; 347 hppa|sh) conf+=" -arch generic" ;;
220 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 348 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
221 esac 349 esac
222 350
223 # Bug 261412 Qt configure detects archs by uname 351 conf+=" -platform $(qt_mkspecs_dir)"
224 case "$(tc-arch)" in
225 ppc) myconf="${myconf} -platform linux-g++-32";;
226 esac
227 352
228 myconf="${myconf} -stl -verbose -largefile -confirm-license -no-rpath 353 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
229 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
230 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
231 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
232 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
233 -demosdir ${QTDEMOSDIR} -silent -fast
234 $([[ ${PN} == qt-xmlpatterns ]] || echo -no-exceptions)
235 -reduce-relocations -nomake examples -nomake demos"
236
237 # Make eclass 4.5.{1,2} ready
238 case "${MY_PV}" in
239 4.5.1 | 4.5.2)
240 myconf="${myconf} -opensource"
241 ;;
242 esac
243 354
355 # debug/release
356 if use debug; then
357 conf+=" -debug"
358 else
359 conf+=" -release"
360 fi
361 conf+=" -no-separate-debug-info"
362
363 # exceptions USE flag
364 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
365
366 # disable RPATH on Qt >= 4.8 (bug 380415)
367 version_is_at_least 4.8 && conf+=" -no-rpath"
368
369 # precompiled headers don't work on hardened, where the flag is masked
370 conf+=" $(qt_use pch)"
371
372 # -reduce-relocations
373 # This flag seems to introduce major breakage to applications,
374 # mostly to be seen as a core dump with the message "QPixmap: Must
375 # construct a QApplication before a QPaintDevice" on Solaris.
376 # -- Daniel Vergien
377 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
378
379 # this one is needed for all systems with a separate -liconv, apart from
380 # Darwin, for which the sources already cater for -liconv
381 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
382 conf+=" -liconv"
383 fi
384
385 if use_if_iuse glib; then
386 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
387 # avoid the -pthread argument
388 conf+=" ${glibflags//-pthread}"
389 unset glibflags
390 fi
391
392 if use_if_iuse qpa; then
393 echo
394 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
395 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
396 ewarn "disable it before reporting any bugs related to this useflag."
397 echo
398 conf+=" -qpa"
399 fi
400
401 if use aqua; then
402 # On (snow) leopard use the new (frameworked) cocoa code.
403 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
404 conf+=" -cocoa -framework"
405 # We need the source's headers, not the installed ones.
406 conf+=" -I${S}/include"
407 # Add hint for the framework location.
408 conf+=" -F${QTLIBDIR}"
409
410 # We are crazy and build cocoa + qt3support :-)
411 if use qt3support; then
412 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
413 -i configure || die
414 fi
415 else
416 conf+=" -no-framework"
417 fi
418 else
419 # freetype2 include dir is non-standard, thus pass it to configure
420 conf+=" $(pkg-config --cflags-only-I freetype2)"
421 fi
422
244 echo "${myconf}" 423 conf+=" ${myconf}"
245} 424 myconf=
246 425
426 echo ./configure ${conf}
427 ./configure ${conf} || die "./configure failed"
428
429 prepare_directories ${QT4_TARGET_DIRECTORIES}
430}
431
432# @FUNCTION: qt4-build_src_compile
433# @DESCRIPTION:
434# Actual compile phase
435qt4-build_src_compile() {
436 setqtenv
437
438 build_directories ${QT4_TARGET_DIRECTORIES}
439}
440
441# @FUNCTION: qt4-build_src_test
442# @DESCRIPTION:
443# Runs tests only in target directories.
444qt4-build_src_test() {
445 # QtMultimedia does not have any test suite (bug #332299)
446 [[ ${PN} == qt-multimedia ]] && return
447
448 for dir in ${QT4_TARGET_DIRECTORIES}; do
449 emake -j1 check -C ${dir}
450 done
451}
452
453# @FUNCTION: fix_includes
454# @DESCRIPTION:
455# For MacOS X we need to add some symlinks when frameworks are
456# being used, to avoid complications with some more or less stupid packages.
457fix_includes() {
458 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
459 # Some packages tend to include <Qt/...>
460 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
461
462 # Fake normal headers when frameworks are installed... eases life later on
463 local dest f h
464 for frw in "${D}${QTLIBDIR}"/*.framework; do
465 [[ -e "${frw}"/Headers ]] || continue
466 f=$(basename ${frw})
467 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
468 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
469
470 # Link normal headers as well.
471 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
472 h=$(basename ${hdr})
473 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
474 done
475 done
476 fi
477}
478
479# @FUNCTION: qt4-build_src_install
480# @DESCRIPTION:
481# Perform the actual installation including some library fixes.
482qt4-build_src_install() {
483 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
484 setqtenv
485
486 install_directories ${QT4_TARGET_DIRECTORIES}
487 install_qconfigs
488 fix_library_files
489 fix_includes
490
491 # remove .la files since we are building only shared Qt libraries
492 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
493}
494
495# @FUNCTION: setqtenv
496# @INTERNAL
497setqtenv() {
498 # Set up installation directories
499 QTPREFIXDIR=${EPREFIX}/usr
500 QTBINDIR=${EPREFIX}/usr/bin
501 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
502 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
503 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
504 QTHEADERDIR=${EPREFIX}/usr/include/qt4
505 QTPLUGINDIR=${QTLIBDIR}/plugins
506 QTIMPORTDIR=${QTLIBDIR}/imports
507 QTDATADIR=${EPREFIX}/usr/share/qt4
508 QTTRANSDIR=${QTDATADIR}/translations
509 QTSYSCONFDIR=${EPREFIX}/etc/qt4
510 QTEXAMPLESDIR=${QTDATADIR}/examples
511 QTDEMOSDIR=${QTDATADIR}/demos
512 QMAKE_LIBDIR_QT=${QTLIBDIR}
513 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
514
515 PLATFORM=$(qt_mkspecs_dir)
516
517 unset QMAKESPEC
518}
519
520# @FUNCTION: prepare_directories
521# @USAGE: < directories >
522# @INTERNAL
523# @DESCRIPTION:
524# Generates Makefiles for the given list of directories.
525prepare_directories() {
526 for x in "$@"; do
527 pushd "${S}"/${x} >/dev/null || die
528 einfo "Running qmake in: ${x}"
529 # avoid running over the maximum argument number, bug #299810
530 {
531 echo "${S}"/mkspecs/common/*.conf
532 find "${S}" -name '*.pr[io]'
533 } | xargs sed -i \
534 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
535 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
536 || die
537 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
538 popd >/dev/null || die
539 done
540}
541
542
543# @FUNCTION: build_directories
544# @USAGE: < directories >
545# @INTERNAL
546# @DESCRIPTION:
547# Compiles the code in the given list of directories.
247build_directories() { 548build_directories() {
248 local dirs="$@"
249 for x in ${dirs}; do 549 for x in "$@"; do
250 cd "${S}"/${x} 550 pushd "${S}"/${x} >/dev/null || die
251 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 551 emake CC="$(tc-getCC)" \
252 emake || die "emake failed" 552 CXX="$(tc-getCXX)" \
553 LINK="$(tc-getCXX)" || die "emake failed"
554 popd >/dev/null || die
253 done 555 done
254} 556}
255 557
558# @FUNCTION: install_directories
559# @USAGE: < directories >
560# @INTERNAL
561# @DESCRIPTION:
562# Runs emake install in the given directories, which are separated by spaces.
256install_directories() { 563install_directories() {
257 local dirs="$@"
258 for x in ${dirs}; do 564 for x in "$@"; do
259 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 565 pushd "${S}"/${x} >/dev/null || die
260 emake INSTALL_ROOT="${D}" install || die "emake install failed" 566 emake INSTALL_ROOT="${D}" install || die "emake install failed"
261 popd >/dev/null || die "Can't popd from ${S}/${x}" 567 popd >/dev/null || die
262 done 568 done
263} 569}
264 570
265# @ECLASS-VARIABLE: QCONFIG_ADD 571# @ECLASS-VARIABLE: QCONFIG_ADD
266# @DESCRIPTION: 572# @DESCRIPTION:
267# List options that need to be added to QT_CONFIG in qconfig.pri 573# List options that need to be added to QT_CONFIG in qconfig.pri
268QCONFIG_ADD="${QCONFIG_ADD:-}" 574: ${QCONFIG_ADD:=}
269 575
270# @ECLASS-VARIABLE: QCONFIG_REMOVE 576# @ECLASS-VARIABLE: QCONFIG_REMOVE
271# @DESCRIPTION: 577# @DESCRIPTION:
272# List options that need to be removed from QT_CONFIG in qconfig.pri 578# List options that need to be removed from QT_CONFIG in qconfig.pri
273QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 579: ${QCONFIG_REMOVE:=}
274 580
275# @ECLASS-VARIABLE: QCONFIG_DEFINE 581# @ECLASS-VARIABLE: QCONFIG_DEFINE
276# @DESCRIPTION: 582# @DESCRIPTION:
277# List variables that should be defined at the top of QtCore/qconfig.h 583# List variables that should be defined at the top of QtCore/qconfig.h
278QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 584: ${QCONFIG_DEFINE:=}
279 585
586# @FUNCTION: install_qconfigs
587# @INTERNAL
588# @DESCRIPTION:
589# Install gentoo-specific mkspecs configurations.
280install_qconfigs() { 590install_qconfigs() {
281 local x 591 local x
282 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 592 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
283 for x in QCONFIG_ADD QCONFIG_REMOVE; do 593 for x in QCONFIG_ADD QCONFIG_REMOVE; do
284 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 594 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
285 done 595 done
286 insinto ${QTDATADIR}/mkspecs/gentoo 596 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
287 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 597 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
288 fi 598 fi
289 599
290 if [[ -n ${QCONFIG_DEFINE} ]]; then 600 if [[ -n ${QCONFIG_DEFINE} ]]; then
291 for x in ${QCONFIG_DEFINE}; do 601 for x in ${QCONFIG_DEFINE}; do
292 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 602 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
293 done 603 done
294 insinto ${QTHEADERDIR}/Gentoo 604 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
295 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 605 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
296 fi 606 fi
297} 607}
298 608
609# @FUNCTION: generate_qconfigs
610# @INTERNAL
611# @DESCRIPTION:
612# Generates gentoo-specific qconfig.{h,pri}.
299generate_qconfigs() { 613generate_qconfigs() {
300 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 614 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
301 local x qconfig_add qconfig_remove qconfig_new 615 local x qconfig_add qconfig_remove qconfig_new
302 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 616 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
303 [[ -f ${x} ]] || continue 617 [[ -f ${x} ]] || continue
304 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 618 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
305 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 619 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
306 done 620 done
307 621
308 # these error checks do not use die because dying in pkg_post{inst,rm} 622 # these error checks do not use die because dying in pkg_post{inst,rm}
309 # just makes things worse. 623 # just makes things worse.
310 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 624 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
317 631
318 # generate list of QT_CONFIG entries from the existing list 632 # generate list of QT_CONFIG entries from the existing list
319 # including qconfig_add and excluding qconfig_remove 633 # including qconfig_add and excluding qconfig_remove
320 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 634 for x in $(sed -n 's/^QT_CONFIG +=//p' \
321 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 635 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
322 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 636 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
323 done 637 done
324 638
325 # replace the existing QT_CONFIG list with qconfig_new 639 # replace the existing QT_CONFIG list with qconfig_new
326 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 640 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
327 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 641 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
350 "${ROOT}${QTHEADERDIR}" 2>/dev/null 664 "${ROOT}${QTHEADERDIR}" 2>/dev/null
351 fi 665 fi
352 fi 666 fi
353} 667}
354 668
669# @FUNCTION: qt4-build_pkg_postrm
670# @DESCRIPTION:
671# Regenerate configuration when the package is completely removed.
355qt4-build_pkg_postrm() { 672qt4-build_pkg_postrm() {
356 generate_qconfigs 673 generate_qconfigs
357} 674}
358 675
676# @FUNCTION: qt4-build_pkg_postinst
677# @DESCRIPTION:
678# Regenerate configuration, plus throw a message about possible
679# breakages and proposed solutions.
359qt4-build_pkg_postinst() { 680qt4-build_pkg_postinst() {
360 generate_qconfigs 681 generate_qconfigs
361 echo
362 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
363 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
364 ewarn "should recompile the packages providing these plugins. Also, make sure you"
365 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
366 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
367 ewarn
368 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
369 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
370 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
371 ewarn "configuration."
372 ewarn
373 ewarn "For more information, see http://doc.trolltech.com/4.4/plugins-howto.html"
374 echo
375} 682}
376 683
684# @FUNCTION: skip_qmake_build
685# @INTERNAL
686# @DESCRIPTION:
687# Patches configure to skip qmake compilation, as it's already installed by qt-core.
377skip_qmake_build_patch() { 688skip_qmake_build() {
378 # Don't need to build qmake, as it's already installed from qt-core
379 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 689 sed -i -e "s:if true:if false:g" "${S}"/configure || die
380} 690}
381 691
382skip_project_generation_patch() { 692# @FUNCTION: skip_project_generation
693# @INTERNAL
694# @DESCRIPTION:
383 # Exit the script early by throwing in an exit before all of the .pro files are scanned 695# Exit the script early by throwing in an exit before all of the .pro files are scanned.
696skip_project_generation() {
384 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 697 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
385 -i "${S}"/configure || die "Sed failed"
386} 698}
387 699
700# @FUNCTION: symlink_binaries_to_buildtree
701# @INTERNAL
702# @DESCRIPTION:
703# Symlinks generated binaries to buildtree, so they can be used during compilation time.
388symlink_binaries_to_buildtree() { 704symlink_binaries_to_buildtree() {
389 for bin in qmake moc uic rcc; do 705 for bin in qmake moc uic rcc; do
390 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 706 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
391 done 707 done
392} 708}
393 709
710# @FUNCTION: fix_library_files
711# @INTERNAL
712# @DESCRIPTION:
713# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
714# moves the *.pc files into the pkgconfig directory.
394fix_library_files() { 715fix_library_files() {
716 local libfile
395 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 717 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
396 if [[ -e ${libfile} ]]; then 718 if [[ -e ${libfile} ]]; then
397 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 719 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
398 fi 720 fi
399 done 721 done
400 722
401 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 723 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
402 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 724 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
403 if [[ -e ${libfile} ]]; then 725 if [[ -e ${libfile} ]]; then
404 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 726 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
405 727
406 # Move .pc files into the pkgconfig directory 728 # Move .pc files into the pkgconfig directory
407
408 dodir ${QTPCDIR} 729 dodir ${QTPCDIR#${EPREFIX}}
409 mv ${libfile} "${D}"/${QTPCDIR}/ \ 730 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
410 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
411 fi 731 fi
412 done 732 done
413 733
414 # Don't install an empty directory 734 # Don't install an empty directory
415 rmdir "${D}"/${QTLIBDIR}/pkgconfig 735 rmdir "${D}"/${QTLIBDIR}/pkgconfig
416} 736}
417 737
738# @FUNCTION: qt_use
739# @USAGE: < flag > [ feature ] [ enableval ]
740# @DESCRIPTION:
741# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
742# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
743# will be used for that. If [enableval] is not specified, it omits the
744# "-${enableval}" part.
418qt_use() { 745qt_use() {
419 local flag="${1}" 746 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
420 local feature="${1}"
421 local enableval=
422
423 [[ -n ${2} ]] && feature=${2}
424 [[ -n ${3} ]] && enableval="-${3}"
425
426 if use ${flag}; then
427 echo "${enableval}-${feature}"
428 else
429 echo "-no-${feature}"
430 fi
431} 747}
432 748
433# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK 749# @FUNCTION: qt_mkspecs_dir
750# @RETURN: the specs-directory w/o path
434# @DESCRIPTION: 751# @DESCRIPTION:
435# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use 752# Allows us to define which mkspecs dir we want to use.
436# (eutils.eclass), line per line.
437#
438# Example:
439# @CODE
440# pkg_setup() {
441# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
442# ~x11-libs/qt-gui-${PV} qt3support"
443# qt4-build_check_use
444# }
445# @CODE
446
447# Run built_with_use on each flag and print appropriate error messages if any
448# flags are missing
449_qt_built_with_use() {
450 local missing opt pkg flag flags
451
452 if [[ ${1} = "--missing" ]]; then
453 missing="${1} ${2}" && shift 2
454 fi
455 if [[ ${1:0:1} = "-" ]]; then
456 opt=${1} && shift
457 fi
458
459 pkg=${1} && shift
460
461 for flag in "${@}"; do
462 flags="${flags} ${flag}"
463 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
464 flags="${flags}*"
465 else
466 [[ ${opt} = "-o" ]] && return 0
467 fi
468 done
469 if [[ "${flags# }" = "${@}" ]]; then
470 return 0
471 fi
472 if [[ ${opt} = "-o" ]]; then
473 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
474 else
475 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
476 fi
477 return 1
478}
479
480# @FUNCTION: qt4-build_check_use
481# @DESCRIPTION:
482# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
483# USE flags listed.
484#
485# If any of the required USE flags are missing, an eerror will be printed for
486# each package with missing USE flags.
487qt4-build_check_use() {
488 local line missing
489 while read line; do
490 [[ -z ${line} ]] && continue
491 if ! _qt_built_with_use ${line}; then
492 missing=true
493 fi
494 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
495 if [[ -n ${missing} ]]; then
496 echo
497 eerror "Flags marked with an * are missing."
498 die "Missing USE flags found"
499 fi
500}
501
502qt_mkspecs_dir() { 753qt_mkspecs_dir() {
503 # Allows us to define which mkspecs dir we want to use.
504 local spec 754 local spec=
505 755
506 case ${CHOST} in 756 case "${CHOST}" in
507 *-freebsd*|*-dragonfly*) 757 *-freebsd*|*-dragonfly*)
508 spec="freebsd" ;; 758 spec=freebsd ;;
509 *-openbsd*) 759 *-openbsd*)
510 spec="openbsd" ;; 760 spec=openbsd ;;
511 *-netbsd*) 761 *-netbsd*)
512 spec="netbsd" ;; 762 spec=netbsd ;;
513 *-darwin*) 763 *-darwin*)
764 if use aqua; then
765 # mac with carbon/cocoa
766 spec=macx
767 else
768 # darwin/mac with x11
514 spec="darwin" ;; 769 spec=darwin
770 fi
771 ;;
772 *-solaris*)
773 spec=solaris ;;
515 *-linux-*|*-linux) 774 *-linux-*|*-linux)
516 spec="linux" ;; 775 spec=linux ;;
517 *) 776 *)
518 die "Unknown CHOST, no platform choosen." 777 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
519 esac 778 esac
520 779
521 CXX=$(tc-getCXX) 780 case "$(tc-getCXX)" in
522 if [[ ${CXX/g++/} != ${CXX} ]]; then 781 *g++*)
523 spec="${spec}-g++" 782 spec+=-g++ ;;
524 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 783 *icpc*)
525 spec="${spec}-icc" 784 spec+=-icc ;;
526 else 785 *)
527 die "Unknown compiler ${CXX}." 786 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
787 esac
788
789 # Add -64 for 64bit profiles
790 if use x64-freebsd ||
791 use amd64-linux ||
792 use x64-macos ||
793 use x64-solaris ||
794 use sparc64-solaris
795 then
796 spec+=-64
528 fi 797 fi
529 798
530 echo "${spec}" 799 echo "${spec}"
531} 800}
532 801
533case ${EAPI:-0} in 802# @FUNCTION: qt_assistant_cleanup
534 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 803# @INTERNAL
804# @DESCRIPTION:
805# Tries to clean up tools.pro for qt-assistant ebuilds.
806# Meant to be called in src_prepare().
807# Since Qt 4.7.4 this function is a no-op.
808qt_assistant_cleanup() {
809 # apply patching to qt-assistant ebuilds only
810 [[ ${PN} != qt-assistant ]] && return
811
812 # no longer needed for 4.7.4 and later
813 version_is_at_least 4.7.4 && return
814
815 # different versions (and branches...) may need different handling,
816 # add a case if you need special handling
817 case "${MY_PV_EXTRA}" in
818 *kde-qt*)
819 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
820 -e "/mac/,/^embedded.*makeqpf$/d" \
821 -i tools/tools.pro || die "patching tools.pro failed"
822 ;;
823 *)
824 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
825 -e "/mac/,/^embedded.*makeqpf$/d" \
826 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
827 -i tools/tools.pro || die "patching tools.pro failed"
828 ;;
829 esac
830}
831
832# @FUNCTION: qt_nolibx11
833# @INTERNAL
834# @DESCRIPTION:
835# Ignore X11 tests for packages that don't need X libraries installed.
836qt_nolibx11() {
837 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
838 die "x11 check sed failed"
839}
840
535 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 841EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
536esac

Legend:
Removed from v.1.33  
changed lines
  Added in v.1.123

  ViewVC Help
Powered by ViewVC 1.1.20